-- guardia.init
-- By daelvn
inspect_count = 0

-- Boolean chain
_filter    = (fl)     -> (...)    -> if fl ... then true, ... else false, ...
_true      = (...)    -> true, ...
_false     = (...)    -> false, ...
_transform = (tr)     -> (b, ...) -> if b then true, tr ... else false, ...
_default   = (v)      -> (...)    -> return (_transform -> v) (_filter (x) -> "nil"==type x) ...
_negate    = (b, ...) -> not b, ...
_error     = (msg)    -> (b, ...) -> if b then error msg else false, ...
_pass      = (b, ...) -> ...
_status    = (b, ...) -> b
_e1        = _error "guardia $ chain was stopped"
_inspect   = (b, ...) ->
  inspect_count += 1
  print inspect_count, b, ...
  return b, ...
_named     = (msg) -> (b, ...) ->
  print msg, b, ...
  return b, ...

-- Aliases
_finalize = _pass
_fn       = _finalize
_ps       = _pass
_fl       = _filter
_tr       = _transform
_ng       = _negate
_er       = _error
_st       = _status
_in       = _inspect
_ci       = _named
_df       = _default
_t        = _true
_f        = _false

-- OR
_or  = (_src1) -> (_src2) -> (...) ->
  a = _st _src1 ...
  b = _st _src2 ...
  return (a or b), ...
_or1 = (sa, sb) -> (_or sa) sb

-- AND
_and  = (_src1) -> (_src2) -> (...) ->
  a = _st _src1 ...
  b = _st _src2 ...
  return (a and b), ...
_and1 = (sa, sb) -> (_and sa) sb

-- XOR
_xor  = (_src1) -> (_src2) -> (...) ->
  a = _st _src1 ...
  b = _st _src2 ...
  return (a != b), ...
_xor1 = (sa, sb) -> (_xor sa) sb

-- v1 Guards
Guard        = (fl) -> (tr)     -> (f) -> (...) -> f _fn (_tr tr) (_fl fl) ...
Antiguard    = (fl) -> (tr)     -> (f) -> (...) -> f _fn (_tr tr) _ng (_fl fl) ...
Biguard      = (fl) -> (tr, ar) -> (f) -> (...) -> f _fn (_tr ar) _ng (_fl fl) _ps (_tr tr) (_fl fl) ...
Endguard     = (fl) -> (tr)     -> (f) -> (...) -> _fn (_tr tr) (_fl fl) f ...
Errguard     = (fl) -> (tr)     -> (f) -> (...) -> f _fn _e1 (_fl fl) f ...
Enderrguard  = (fl) -> (tr)     -> (f) -> (...) -> _fn _e1 f ...
Antierrguard = (fl) -> (tr)     -> (f) -> (...) -> f _fm _e1 _ng (_fl fl) f ...

{
  :_filter,    :_fl
  :_transform, :_tr
  :_negate,    :_ng
  :_pass,      :_ps
  :_error,     :_er, :_e1
  :_status,    :_st
  :_finalize,  :_fn
  :_inspect,   :_in
  :_named,     :_ci
  :_default,   :_df
  :_true,      :_t
  :_false,     :_f
  :_or,      :_or1
  :_and,       :_and1
  :_xor,       :_xor1
    :Guard
  :Antiguard
  :Biguard
  :Endguard
  :Errguard
  :Enderrguard
  :Antierrguard
}
